import {
  TransitionalStyles
} from "./chunk.EUES6BVY.js";
import {
  GdsElement
} from "./chunk.TMEWQZER.js";
import {
  gdsCustomElement,
  html
} from "./chunk.QK3R23GV.js";
import {
  __decorateClass
} from "./chunk.SEHSDSX2.js";

// libs/core/src/components/filter-chips/filter-chip/filter-chip.ts
import { property } from "lit/decorators.js";
import { classMap } from "lit/directives/class-map.js";

// libs/core/src/components/filter-chips/filter-chip/filter-chip.styles.ts
import { css } from "lit";
var styles = css`
  @layer base, reset, transitional-styles;
  @layer base {
    .btn-p {
      padding: 0 0.75rem;
    }
    .icon {
      width: 1rem;
    }
  }
`;

// libs/core/src/components/filter-chips/filter-chip/filter-chip.ts
var GdsFilterChip = class extends GdsElement {
  constructor() {
    super(...arguments);
    this.selected = false;
  }
  connectedCallback() {
    super.connectedCallback();
    this.setAttribute("role", "none");
    TransitionalStyles.instance.apply(this, "gds-filter-chip");
  }
  render() {
    const btnClasses = {
      "btn-p": !this.selected
    };
    return html`<gds-button
      class="btn"
      size="small"
      .rank=${this.selected ? "primary" : "secondary"}
      variant=${this._isUsingTransitionalStyles ? "ghost" : "default"}
      gds-role="option"
      gds-aria-selected=${this.selected}
    >
      <span class=${classMap(btnClasses)}><slot></slot></span>
      <gds-icon-checkmark
        slot="trail"
        style="display: ${this.selected ? "contents" : "none"}"
        width="16"
        height="16"
        class="icon"
      ></gds-icon-checkmark>
    </gds-button>`;
  }
};
GdsFilterChip.styles = [styles];
__decorateClass([
  property({ reflect: true, type: Boolean })
], GdsFilterChip.prototype, "selected", 2);
__decorateClass([
  property()
], GdsFilterChip.prototype, "value", 2);
GdsFilterChip = __decorateClass([
  gdsCustomElement("gds-filter-chip")
], GdsFilterChip);

export {
  GdsFilterChip
};
