import {
  withSizeXProps
} from "./chunk.TWXTKG4B.js";
import {
  TransitionalStyles
} from "./chunk.EUES6BVY.js";
import {
  tokens
} from "./chunk.FI4AQLJC.js";
import {
  GdsElement
} from "./chunk.TMEWQZER.js";
import {
  gdsCustomElement,
  html
} from "./chunk.QK3R23GV.js";
import {
  __decorateClass
} from "./chunk.SEHSDSX2.js";

// libs/core/src/components/segmented-control/segment/segment.ts
import { unsafeCSS } from "lit";
import { property } from "lit/decorators.js";

// libs/core/src/components/segmented-control/segment/segment.style.css?inline
var segment_style_default = `@layer base {
  :host {
    display: flex;
    z-index: 1;
  }

  button {
    -webkit-appearance: none;
       -moz-appearance: none;
            appearance: none;
    background: transparent;
    border-radius: var(--gds-space-max);
    border-width: 0;
    color: var(--gds-color-l3-content-tertiary);
    cursor: pointer;
    flex-grow: 1;
    flex-shrink: 0;
    font-family: inherit;
    font-size: inherit;
    overflow: hidden;
    padding: 0 1rem;
    text-align: center;
    text-overflow: ellipsis;
    white-space: nowrap;
    width: 100%;
    transition:
      background-color 0.2s,
      border-color 0.2s,
      color 0.2s,
      outline-color 422ms;

    outline-width: var(--gds-size-3xs);
    outline-style: solid;
    outline-offset: -2px;
    outline-color: transparent;

    &:disabled {
      cursor: not-allowed;
      opacity: 0.5;
    }
  }

  @media (pointer: fine) {
    :host(:not([selected])) button:hover {
      background-color: color-mix(
        in srgb,
        var(--gds-color-l3-states-light-hover),
        transparent
      );

      &:disabled {
        background-color: transparent;
      }
    }
  }

  button:focus-visible {
    outline-color: color-mix(
      in srgb,
      transparent,
      var(--gds-color-l3-content-tertiary) 100%
    );
  }
}
`;

// libs/core/src/components/segmented-control/segment/segment.ts
var GdsSegment = class extends withSizeXProps(GdsElement) {
  constructor() {
    super(...arguments);
    this.selected = false;
    this.disabled = false;
    // This is deliberatly not marked as private, since we're setting it from the parent component,
    // but it is not meant to be set by the consumer.
    this._isVisible = true;
  }
  /**
   * Whether the segment is currently visible.
   */
  get isVisible() {
    return this._isVisible;
  }
  connectedCallback() {
    super.connectedCallback();
    TransitionalStyles.instance.apply(this, "gds-segmented");
    this.setAttribute("role", "listitem");
  }
  render() {
    return html`<button
      aria-current=${String(this.selected)}
      ?disabled="${this.disabled}"
    >
      <slot></slot>
    </button>`;
  }
};
GdsSegment.styles = [...tokens, unsafeCSS(segment_style_default)];
__decorateClass([
  property({ type: Boolean, reflect: true })
], GdsSegment.prototype, "selected", 2);
__decorateClass([
  property()
], GdsSegment.prototype, "value", 2);
__decorateClass([
  property({ type: Boolean, reflect: true })
], GdsSegment.prototype, "disabled", 2);
GdsSegment = __decorateClass([
  gdsCustomElement("gds-segment")
], GdsSegment);

export {
  GdsSegment
};
