import {
  GdsDiv
} from "./chunk.BCIZMK2U.js";
import {
  forSpaceTokens
} from "./chunk.76QWARGM.js";
import {
  styleExpressionProperty
} from "./chunk.NUUST5OZ.js";
import {
  tokens
} from "./chunk.FI4AQLJC.js";
import {
  gdsCustomElement,
  html
} from "./chunk.QK3R23GV.js";
import {
  __decorateClass,
  __spreadProps,
  __spreadValues
} from "./chunk.SEHSDSX2.js";

// libs/core/src/components/grid/grid.style.ts
import { css } from "lit";
var style = css`
  :host {
    --_c: 12;
    --_grid-col: repeat(var(--_c), 1fr);
    width: 100%;
    display: grid;
    grid-template-columns: var(--_grid-col);
    grid-column-gap: var(--_gap-column, 0px);
    grid-row-gap: var(--_gap-row, 0px);
  }

  :host([auto-columns]) {
    --_col-count: var(--_c, 0);
    --_gap-count: calc(var(--_col-count) - 1);
    --_total-gap-width: calc(var(--_gap-count) * var(--_gap-column, 0px));
    --_col-width-max: calc(
      (100% - var(--_total-gap-width)) / var(--_col-count)
    );
    grid-template-columns: repeat(
      auto-fill,
      minmax(max(var(--_col-width), var(--_col-width-max)), 1fr)
    );
  }
`;
var grid_style_default = style;

// libs/core/src/components/grid/grid.ts
var GdsGrid = class extends GdsDiv {
  render() {
    return html`<slot></slot>`;
  }
};
GdsGrid.styles = [tokens, grid_style_default];
__decorateClass([
  styleExpressionProperty({
    property: "--_c"
  })
], GdsGrid.prototype, "columns", 2);
__decorateClass([
  styleExpressionProperty(__spreadProps(__spreadValues({}, forSpaceTokens), {
    styleTemplate: (_prop, values) => {
      const rowGap = values[0];
      const colGap = values[1] || rowGap;
      return `--_gap-column: ${colGap}; --_gap-row: ${rowGap};`;
    }
  }))
], GdsGrid.prototype, "gap", 2);
__decorateClass([
  styleExpressionProperty({
    property: "--_col-width",
    valueTemplate: (v) => `${isNaN(v) ? v : `${v}px`}`
  })
], GdsGrid.prototype, "auto-columns", 2);
GdsGrid = __decorateClass([
  gdsCustomElement("gds-grid")
], GdsGrid);

export {
  GdsGrid
};
