import {
  withLayoutChildProps,
  withMarginProps,
  withPaddingProps,
  withPositioningProps,
  withSizeXProps,
  withSizeYProps
} from "./chunk.TWXTKG4B.js";
import {
  forColorTokens,
  forSpaceTokens,
  parseColorValue
} from "./chunk.76QWARGM.js";
import {
  styleExpressionProperty
} from "./chunk.NUUST5OZ.js";
import {
  tokens
} from "./chunk.FI4AQLJC.js";
import {
  GdsElement
} from "./chunk.TMEWQZER.js";
import {
  gdsCustomElement,
  html
} from "./chunk.QK3R23GV.js";
import {
  __decorateClass,
  __spreadProps,
  __spreadValues
} from "./chunk.SEHSDSX2.js";

// libs/core/src/components/div/div.ts
import { property } from "lit/decorators.js";

// libs/core/src/components/div/div.style.ts
import { css } from "lit";
var style = css`
  :host {
    display: block;
    box-sizing: border-box;
    border-style: solid;
    border-width: 0;
    border-color: var(--gds-color-l2-border-primary);
  }
  :host(:focus-visible) {
    outline-color: color-mix(in srgb, currentcolor, #000 100%);
    outline-offset: var(--gds-space-3xs);
    outline-style: solid;
    outline-width: var(--gds-space-3xs);
  }
`;
var div_style_default = style;

// libs/core/src/components/div/div.ts
var GdsDiv = class extends withSizeXProps(
  withSizeYProps(
    withMarginProps(
      withPaddingProps(withLayoutChildProps(withPositioningProps(GdsElement)))
    )
  )
) {
  constructor() {
    super(...arguments);
    this.level = "2";
  }
  render() {
    return html`<slot></slot>`;
  }
};
GdsDiv.styles = [tokens, div_style_default];
__decorateClass([
  styleExpressionProperty()
], GdsDiv.prototype, "display", 2);
__decorateClass([
  property()
], GdsDiv.prototype, "level", 2);
__decorateClass([
  styleExpressionProperty(forColorTokens("content"))
], GdsDiv.prototype, "color", 2);
__decorateClass([
  styleExpressionProperty(forColorTokens("background"))
], GdsDiv.prototype, "background", 2);
__decorateClass([
  styleExpressionProperty({
    styleTemplate: function(_prop, values) {
      const this_ = this;
      const [
        size,
        style2 = this_["border-style"] || "solid",
        color = this_["border-color"] || "primary"
      ] = values;
      const sizeCss = `var(--gds-space-${size})`;
      const colorCss = parseColorValue(color, "border", this_.level);
      return `border: ${sizeCss} ${style2} ${colorCss};`;
    }
  })
], GdsDiv.prototype, "border", 2);
__decorateClass([
  styleExpressionProperty(forColorTokens("border"))
], GdsDiv.prototype, "border-color", 2);
__decorateClass([
  styleExpressionProperty(forSpaceTokens)
], GdsDiv.prototype, "border-width", 2);
__decorateClass([
  styleExpressionProperty()
], GdsDiv.prototype, "border-style", 2);
__decorateClass([
  styleExpressionProperty(forSpaceTokens)
], GdsDiv.prototype, "border-radius", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => `var(--gds-shadow-${v})`
  })
], GdsDiv.prototype, "box-shadow", 2);
__decorateClass([
  styleExpressionProperty()
], GdsDiv.prototype, "opacity", 2);
__decorateClass([
  styleExpressionProperty()
], GdsDiv.prototype, "overflow", 2);
__decorateClass([
  styleExpressionProperty()
], GdsDiv.prototype, "box-sizing", 2);
__decorateClass([
  styleExpressionProperty()
], GdsDiv.prototype, "z-index", 2);
__decorateClass([
  styleExpressionProperty({
    styleTemplate: (_prop, values) => {
      const size = values[0];
      const styleSize = `font-size: var(--gds-text-size-${size});`;
      const styleLine = `line-height: var(--gds-text-line-height-${size});`;
      return styleSize + styleLine;
    }
  })
], GdsDiv.prototype, "font-size", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => `var(--gds-text-weight-${v})`
  })
], GdsDiv.prototype, "font-weight", 2);
__decorateClass([
  styleExpressionProperty()
], GdsDiv.prototype, "text-align", 2);
__decorateClass([
  styleExpressionProperty()
], GdsDiv.prototype, "text-wrap", 2);
__decorateClass([
  styleExpressionProperty(__spreadProps(__spreadValues({}, forSpaceTokens), {
    styleTemplate: (_prop, values) => {
      const colGap = values[0];
      const rowGap = values[1] || colGap;
      return `gap: ${colGap} ${rowGap};`;
    },
    cacheOverrideKey: "flex"
  }))
], GdsDiv.prototype, "gap", 2);
__decorateClass([
  styleExpressionProperty()
], GdsDiv.prototype, "align-items", 2);
__decorateClass([
  styleExpressionProperty()
], GdsDiv.prototype, "align-content", 2);
__decorateClass([
  styleExpressionProperty()
], GdsDiv.prototype, "justify-content", 2);
__decorateClass([
  styleExpressionProperty()
], GdsDiv.prototype, "justify-items", 2);
__decorateClass([
  styleExpressionProperty()
], GdsDiv.prototype, "flex-direction", 2);
__decorateClass([
  styleExpressionProperty()
], GdsDiv.prototype, "flex-wrap", 2);
__decorateClass([
  styleExpressionProperty()
], GdsDiv.prototype, "place-items", 2);
__decorateClass([
  styleExpressionProperty()
], GdsDiv.prototype, "place-content", 2);
GdsDiv = __decorateClass([
  gdsCustomElement("gds-div")
], GdsDiv);

export {
  GdsDiv
};
