import {
  resizeObserver
} from "./chunk.VHN4JEZC.js";
import {
  withLayoutChildProps,
  withMarginProps,
  withSizeXProps
} from "./chunk.TWXTKG4B.js";
import {
  TransitionalStyles
} from "./chunk.EUES6BVY.js";
import {
  watch
} from "./chunk.TYGMNHNO.js";
import {
  tokens
} from "./chunk.FI4AQLJC.js";
import {
  GdsElement
} from "./chunk.TMEWQZER.js";
import {
  gdsCustomElement,
  html
} from "./chunk.QK3R23GV.js";
import {
  __decorateClass,
  __privateAdd,
  __privateGet,
  __privateMethod,
  __privateSet
} from "./chunk.SEHSDSX2.js";

// libs/core/src/components/segmented-control/segmented-control.ts
import { localized, msg } from "@lit/localize";
import { unsafeCSS } from "lit";
import { property, query, state } from "lit/decorators.js";

// libs/core/src/components/segmented-control/segmented-control.style.css?inline
var segmented_control_style_default = `@layer base {
  :host {
    background-color: var(--gds-color-l3-background-secondary);
    border: 0.25rem solid transparent;
    border-radius: var(--gds-space-max);
    box-sizing: border-box;
    contain: layout;
    display: inline-flex;
    height: 3rem;
    width: 100%;
    position: relative;
    overflow: hidden;
  }

  :host([size='small']) {
    height: 2.5rem;
  }

  #track {
    box-sizing: border-box;
    display: flex;
    flex-grow: 1;
    scroll-snap-type: inline mandatory;
    overscroll-behavior-x: contain;
    scroll-behavior: smooth;
    overflow-x: scroll;
    gap: 0.25rem;
    position: relative;
    scrollbar-width: none;
  }

  #track::-webkit-scrollbar {
    display: none;
  }

  #btn-prev,
  #btn-next {
    box-sizing: border-box;
    align-items: center;
    -webkit-appearance: none;
       -moz-appearance: none;
            appearance: none;
    aspect-ratio: 1;
    border-radius: var(--gds-space-max);
    border-width: 0;
    background-color: var(--gds-color-l3-background-secondary);
    color: var(--gds-color-l3-content-tertiary);
    cursor: pointer;
    display: flex;
    font-size: 1rem;
    height: 100%;
    justify-content: center;
    width: 2.5rem;
    transition: 0.2s;
    z-index: 2;
    position: absolute;

    @media (pointer: fine) {
      &:hover {
        background-color: color-mix(
          in srgb,
          var(--gds-color-l3-background-secondary),
          var(--gds-color-l3-states-light-hover)
        );
      }
    }
  }
  #btn-prev {
    margin: 0 0.25rem 0 0;
  }
  #btn-next {
    margin: 0 0 0 0.25rem;
    right: 0;
  }

  #btn-prev[aria-hidden='true'],
  #btn-next[aria-hidden='true'] {
    opacity: 0;
    width: 0;
    margin: 0;
    padding: 0;
  }

  :host([size='small']) #btn-prev,
  :host([size='small']) #btn-next {
    width: 2rem;
  }

  ::slotted(*) {
    flex-grow: 1;
    flex-shrink: 0;
    z-index: 1;
    scroll-margin: 0 2.75rem;
    scroll-snap-align: start;
  }

  #indicator {
    background-color: var(--gds-color-l3-background-quarternary);
    border-radius: var(--gds-space-max);
    height: 100%;
    left: 0;
    position: absolute;
    z-index: 0;
    transition:
      transform 0.2s,
      width 0.2s;
    z-index: 0;
  }
}
`;

// libs/core/src/components/segmented-control/segmented-control.ts
var debounce = (fn, delay) => {
  let timeoutId;
  return () => {
    clearTimeout(timeoutId);
    timeoutId = setTimeout(fn, delay);
  };
};
var _value, _handleSlotChange, handleSlotChange_fn, _scrollLeft, _scrollRight, _updateScrollBtnState, _updateScrollBtnStateDebounced, _updateIndicator, _handleSegmentClick, _updateSelectedFromValue;
var GdsSegmentedControl = class extends withLayoutChildProps(
  withSizeXProps(withMarginProps(GdsElement))
) {
  constructor() {
    super(...arguments);
    __privateAdd(this, _handleSlotChange);
    this.size = "medium";
    __privateAdd(this, _value, void 0);
    this._showPrevButton = false;
    this._showNextButton = false;
    this.intersectionObserver = null;
    __privateAdd(this, _scrollLeft, () => {
      const nextLeftOutOfView = this.segments.filter(
        (s, i, arr) => {
          var _a;
          return ((_a = arr[i + 1]) == null ? void 0 : _a.isVisible) && !s.isVisible;
        }
      )[0];
      if (!nextLeftOutOfView)
        return;
      this._elTrack.scrollLeft -= nextLeftOutOfView.offsetWidth;
    });
    __privateAdd(this, _scrollRight, () => {
      const nextRightOutOfView = this.segments.filter((s, i, arr) => {
        var _a;
        return ((_a = arr[i - 1]) == null ? void 0 : _a.isVisible) && !s.isVisible;
      }).reverse()[0];
      if (!nextRightOutOfView)
        return;
      this._elTrack.scrollLeft += nextRightOutOfView.offsetWidth;
    });
    // Updates the visibility of the scroll buttons
    __privateAdd(this, _updateScrollBtnState, () => {
      if (this.segments.every((s) => !s.isVisible))
        return;
      this._showPrevButton = !this.segments[0].isVisible;
      this._showNextButton = !this.segments[this.segments.length - 1].isVisible;
    });
    __privateAdd(this, _updateScrollBtnStateDebounced, debounce(__privateGet(this, _updateScrollBtnState), 50));
    // Updates the selection indicator position
    __privateAdd(this, _updateIndicator, () => {
      const segment = this.segments.find((s) => s.selected);
      if (segment) {
        const segmentWidth = segment.offsetWidth;
        const segmentLeft = segment.offsetLeft;
        this._elIndicator.style.transform = `translateX(${segmentLeft}px)`;
        this._elIndicator.style.width = `${segmentWidth}px`;
      } else {
        this._elIndicator.style.transform = `translateX(-100%)`;
        this._elIndicator.style.width = `0px`;
      }
    });
    __privateAdd(this, _handleSegmentClick, (event) => {
      const selectedSegment = this.segments.find(
        (s) => s === event.target || s.contains(event.target)
      );
      if (selectedSegment) {
        this.segments.forEach((s) => s.selected = false);
        selectedSegment.selected = true;
        __privateSet(this, _value, selectedSegment.value);
        __privateGet(this, _updateIndicator).call(this);
        this.dispatchEvent(
          new CustomEvent("change", {
            detail: { segment: selectedSegment },
            bubbles: true,
            composed: true
          })
        );
      }
    });
    __privateAdd(this, _updateSelectedFromValue, () => {
      if (!__privateGet(this, _value))
        return;
      this.updateComplete.then(() => {
        const selectedSegment = this.segments.find((s) => s.value === __privateGet(this, _value));
        if (selectedSegment) {
          this.segments.forEach((s) => s.selected = false);
          selectedSegment.selected = true;
          this._elTrack.scrollLeft = selectedSegment.offsetLeft;
        }
      });
    });
  }
  get value() {
    return __privateGet(this, _value);
  }
  set value(val) {
    __privateSet(this, _value, val);
    __privateGet(this, _updateSelectedFromValue).call(this);
  }
  /**
   * Returns the segments in the control
   * @readonly
   */
  get segments() {
    return this._elSlot ? this._elSlot.assignedElements() : [];
  }
  connectedCallback() {
    super.connectedCallback();
    TransitionalStyles.instance.apply(this, "gds-segmented-control");
    this.updateComplete.then(() => {
      this._elTrack.addEventListener("scroll", () => {
        __privateGet(this, _updateScrollBtnStateDebounced).call(this);
      });
    });
  }
  render() {
    return html`<button
        aria-hidden=${!this._showPrevButton}
        ?inert=${!this._showPrevButton}
        id="btn-prev"
        @click=${__privateGet(this, _scrollLeft)}
        aria-label=${msg("Scroll right")}
      >
        <gds-icon-chevron-left />
      </button>
      <div id="track" role="list">
        <slot
          @click=${__privateGet(this, _handleSegmentClick)}
          @slotchange=${__privateMethod(this, _handleSlotChange, handleSlotChange_fn)}
          role="none"
        ></slot>
        <div id="indicator" role="none"></div>
      </div>
      <button
        aria-hidden=${!this._showNextButton}
        ?inert=${!this._showNextButton}
        id="btn-next"
        @click=${__privateGet(this, _scrollRight)}
        aria-label=${msg("Scroll right")}
      >
        <gds-icon-chevron-right />
      </button>`;
  }
  _recalculateMinWidth() {
    this.updateComplete.then(() => {
      __privateGet(this, _updateScrollBtnStateDebounced).call(this);
      __privateGet(this, _updateIndicator).call(this);
    });
  }
};
_value = new WeakMap();
_handleSlotChange = new WeakSet();
handleSlotChange_fn = function() {
  var _a, _b;
  const selSegmentValue = (_a = this.segments.find((s) => s.selected)) == null ? void 0 : _a.value;
  if (selSegmentValue) {
    __privateSet(this, _value, selSegmentValue);
  }
  (_b = this.intersectionObserver) == null ? void 0 : _b.disconnect();
  this.intersectionObserver = new IntersectionObserver(
    (entries) => {
      entries.forEach((entry) => {
        const segment = entry.target;
        segment._isVisible = entry.intersectionRatio > 0.99;
        __privateGet(this, _updateScrollBtnStateDebounced).call(this);
      });
    },
    {
      root: this._elTrack,
      threshold: [0, 0.01, 0.5, 0.99, 1]
    }
  );
  this.segments.forEach((s) => {
    var _a2;
    (_a2 = this.intersectionObserver) == null ? void 0 : _a2.observe(s);
  });
};
_scrollLeft = new WeakMap();
_scrollRight = new WeakMap();
_updateScrollBtnState = new WeakMap();
_updateScrollBtnStateDebounced = new WeakMap();
_updateIndicator = new WeakMap();
_handleSegmentClick = new WeakMap();
_updateSelectedFromValue = new WeakMap();
GdsSegmentedControl.styles = [tokens, unsafeCSS(segmented_control_style_default)];
__decorateClass([
  property({ reflect: true })
], GdsSegmentedControl.prototype, "size", 2);
__decorateClass([
  property()
], GdsSegmentedControl.prototype, "value", 1);
__decorateClass([
  query("slot")
], GdsSegmentedControl.prototype, "_elSlot", 2);
__decorateClass([
  query("#indicator")
], GdsSegmentedControl.prototype, "_elIndicator", 2);
__decorateClass([
  query("#track")
], GdsSegmentedControl.prototype, "_elTrack", 2);
__decorateClass([
  state()
], GdsSegmentedControl.prototype, "_showPrevButton", 2);
__decorateClass([
  state()
], GdsSegmentedControl.prototype, "_showNextButton", 2);
__decorateClass([
  resizeObserver(),
  watch("value")
], GdsSegmentedControl.prototype, "_recalculateMinWidth", 1);
GdsSegmentedControl = __decorateClass([
  gdsCustomElement("gds-segmented-control"),
  localized()
], GdsSegmentedControl);

export {
  GdsSegmentedControl
};
