import {
  GdsElement
} from "./chunk.TMEWQZER.js";
import {
  gdsCustomElement,
  html
} from "./chunk.QK3R23GV.js";
import {
  __decorateClass,
  __privateAdd,
  __privateMethod
} from "./chunk.SEHSDSX2.js";

// libs/core/src/primitives/form-control-footer/form-control-footer.ts
import { property } from "lit/decorators.js";
import { when } from "lit/directives/when.js";

// libs/core/src/primitives/form-control-footer/form-control-footer.styles.ts
import { css } from "lit";
var styles = css`
  @layer base, reset, transitional-styles;
  @layer base {
    :host > *:not(style) {
      display: flex;
      justify-content: space-between;
      align-items: center;
      gap: var(--gds-space-xl);
    }

    .error-message {
      display: flex;
      align-items: flex-start;
      gap: var(--gds-space-xs);
      margin-top: var(--gds-space-2xs);
      font-weight: var(--gds-text-weight-book);
      font-size: var(--gds-text-size-detail-s);
      color: var(--gds-color-l3-content-negative);
    }

    [gds-element^='gds-icon'] {
      width: 18px;
      height: 18px;
    }

    :host(.size-small) {
      & .error-message {
        font-size: var(--gds-text-size-detail-xs);
        line-height: var(--gds-text-line-height-detail-s);
        gap: var(--gds-space-2xs);
      }
      & [gds-element^='gds-icon'] {
        width: 16px;
        height: 16px;
        line-height: 16px;
        margin-right: 2px;
      }
    }
  }
`;

// libs/core/src/primitives/form-control-footer/form-control-footer.ts
var _renderRemainingCharsBadge, renderRemainingCharsBadge_fn;
var GdsFormControlFooter = class extends GdsElement {
  constructor() {
    super(...arguments);
    __privateAdd(this, _renderRemainingCharsBadge);
  }
  render() {
    return html`<div aria-live="polite">
      <div class="error-message">
        <slot name="message"
          >${when(
      this.validationMessage,
      () => html`
              <gds-icon-triangle-exclamation
                solid
              ></gds-icon-triangle-exclamation>
              ${this.validationMessage}
            `
    )}</slot
        >
      </div>
      <div class="char-counter">
        ${when(
      Number.isInteger(this.charCounter),
      () => __privateMethod(this, _renderRemainingCharsBadge, renderRemainingCharsBadge_fn).call(this, this.charCounter)
    )}
      </div>
    </div>`;
  }
};
_renderRemainingCharsBadge = new WeakSet();
renderRemainingCharsBadge_fn = function(remaining) {
  let variant;
  if (remaining < 0) {
    variant = "negative";
  } else if (remaining < 20) {
    variant = "warning";
  } else {
    variant = "positive";
  }
  return html`<gds-badge variant="${variant}">${remaining}</gds-badge>`;
};
GdsFormControlFooter.styles = [styles];
__decorateClass([
  property({ type: Number })
], GdsFormControlFooter.prototype, "charCounter", 2);
__decorateClass([
  property()
], GdsFormControlFooter.prototype, "validationMessage", 2);
GdsFormControlFooter = __decorateClass([
  gdsCustomElement("gds-form-control-footer")
], GdsFormControlFooter);

export {
  GdsFormControlFooter
};
