import {
  defaultStyles
} from "./chunk.2JGBCOIQ.js";
import {
  GdsDiv
} from "./chunk.BCIZMK2U.js";
import {
  styleExpressionProperty
} from "./chunk.NUUST5OZ.js";
import {
  tokens
} from "./chunk.FI4AQLJC.js";
import {
  gdsCustomElement
} from "./chunk.QK3R23GV.js";
import {
  __decorateClass
} from "./chunk.SEHSDSX2.js";

// libs/core/src/components/text/text.ts
import { property } from "lit/decorators.js";
import { html, unsafeStatic } from "lit/static-html.js";

// libs/core/src/components/text/text.style.ts
import { css } from "lit";
var style = css`
  :host {
    display: block;
  }

  [tag] {
    margin: 0;
    padding: 0;
    text-underline-offset: 0.2lh;
  }
`;
var text_style_default = style;

// libs/core/src/components/text/text.ts
var GdsText = class extends GdsDiv {
  constructor() {
    super(...arguments);
    this.tag = "span";
  }
  render() {
    const TAG = unsafeStatic(encodeURI(this.tag));
    return html`<${TAG} tag><slot></slot></${TAG}>`;
  }
};
GdsText.styles = [tokens, defaultStyles, text_style_default];
__decorateClass([
  property({ type: String })
], GdsText.prototype, "tag", 2);
__decorateClass([
  styleExpressionProperty({
    selector: "[tag]",
    styleTemplate: (_prop, values) => {
      const size = values[0];
      const styleSize = `font-size: var(--gds-text-size-${size});`;
      const styleLine = `line-height: var(--gds-text-line-height-${size});`;
      return styleSize + styleLine;
    }
  })
], GdsText.prototype, "font-size", 2);
__decorateClass([
  styleExpressionProperty({
    selector: "[tag]",
    valueTemplate: (v) => `var(--gds-text-weight-${v})`
  })
], GdsText.prototype, "font-weight", 2);
__decorateClass([
  styleExpressionProperty()
], GdsText.prototype, "text-transform", 2);
__decorateClass([
  styleExpressionProperty({
    selector: "[tag]"
  })
], GdsText.prototype, "text-decoration", 2);
__decorateClass([
  styleExpressionProperty({
    styleTemplate: (_prop, values) => {
      return `overflow: hidden;
      text-overflow: ellipsis;
      display: -webkit-box;
      -webkit-line-clamp: ${values[0]};
      -webkit-box-orient: vertical;`;
    }
  })
], GdsText.prototype, "lines", 2);
GdsText = __decorateClass([
  gdsCustomElement("gds-text")
], GdsText);

export {
  GdsText
};
