import {
  resizeObserver
} from "./chunk.VHN4JEZC.js";
import {
  forwardAttributes
} from "./chunk.LPLK7FFY.js";
import {
  GdsFormControlElement
} from "./chunk.VA6TUMR2.js";
import {
  withLayoutChildProps,
  withMarginProps,
  withSizeXProps
} from "./chunk.TWXTKG4B.js";
import {
  styleExpressionProperty
} from "./chunk.NUUST5OZ.js";
import {
  watch
} from "./chunk.TYGMNHNO.js";
import {
  tokens
} from "./chunk.FI4AQLJC.js";
import {
  gdsCustomElement,
  html
} from "./chunk.QK3R23GV.js";
import {
  __decorateClass,
  __privateAdd,
  __privateGet,
  __privateMethod
} from "./chunk.SEHSDSX2.js";

// libs/core/src/components/textarea/textarea.ts
import { localized, msg } from "@lit/localize";
import { property, query, queryAsync } from "lit/decorators.js";
import { choose } from "lit/directives/choose.js";
import { nothing } from "lit/html.js";

// libs/core/src/components/textarea/textarea.styles.ts
import { css } from "lit";
var styles = css`
  @layer base, simplified;

  @layer base {
    * {
      box-sizing: border-box;
    }

    :host {
      display: flex;
      flex-direction: column;
      width: 100%;
      contain: layout;
      isolation: isolate;
      gap: var(--gds-space-xs);
    }

    textarea {
      appearance: none;
      background-color: transparent;
      border: 0;
      box-sizing: border-box;
      font-family: inherit;
      font-size: var(--gds-text-size-detail-m);
      height: calc(1lh * var(--_lines));
      line-height: var(--gds-text-line-height-detail-m);
      margin: unset;
      min-height: calc(1lh * 4);
      max-height: calc(1lh * 20);
      overflow: auto;
      outline: none;
      padding: unset;
      width: 100%;
      min-width: 20ch;
      padding-inline-end: calc(var(--gds-space-xs) + var(--padding-inline-end));

      &.resize-manual {
        resize: vertical;
      }

      &.resize-auto {
        resize: none;
      }

      &.resize-false {
        resize: none;
      }
    }

    :host([size='small']) slot[name='lead']::slotted(*) {
      width: var(--gds-space-m);
    }

    slot[name='lead']::slotted(*) {
      min-width: var(--gds-space-l);
      display: flex;
    }

    [align-items] ::part(_button) {
      margin-top: calc(var(--gds-space-2xs) * -1);
    }
  }

  @layer simplified {
  }
`;

// libs/core/src/components/textarea/textarea.ts
var _renderDefault, renderDefault_fn, _renderFloatingLabel, renderFloatingLabel_fn, _forwardableAttrs, _handleOnInput, _handleOnChange, _handleOnPaste, _handleFieldClick, _handleClearBtnClick, _renderFieldContents, renderFieldContents_fn, _renderSlotLead, renderSlotLead_fn, _renderSlotTrail, renderSlotTrail_fn, _renderNativeTextarea, renderNativeTextarea_fn, _renderClearButton, renderClearButton_fn, _shouldShowRemainingChars, shouldShowRemainingChars_get;
var Textarea = class extends GdsFormControlElement {
  constructor() {
    super();
    __privateAdd(this, _renderDefault);
    __privateAdd(this, _renderFloatingLabel);
    __privateAdd(this, _renderFieldContents);
    __privateAdd(this, _renderSlotLead);
    __privateAdd(this, _renderSlotTrail);
    __privateAdd(this, _renderNativeTextarea);
    __privateAdd(this, _renderClearButton);
    __privateAdd(this, _shouldShowRemainingChars);
    this._defaultRows = 4;
    this.rows = 4;
    this.supportingText = "";
    this.clearable = false;
    this.resizable = "auto";
    this.maxlength = Number.MAX_SAFE_INTEGER;
    this.variant = "default";
    this.size = "large";
    this._handleSlotChange = () => {
      requestAnimationFrame(() => {
        this._handleResize();
      });
    };
    // Any attribute name added here will get forwarded to the native <input> element.
    __privateAdd(this, _forwardableAttrs, (attr) => ["type", "placeholder", "required"].includes(attr.name));
    __privateAdd(this, _handleOnInput, (e) => {
      const element = e.target;
      this.value = element.value;
    });
    __privateAdd(this, _handleOnChange, (e) => {
      const element = e.target;
      this.value = element.value;
      this.dispatchEvent(
        new Event("change", {
          bubbles: true,
          composed: true
        })
      );
    });
    __privateAdd(this, _handleOnPaste, (e) => {
      requestAnimationFrame(() => {
        this._setAutoHeight();
      });
    });
    __privateAdd(this, _handleFieldClick, () => {
      this.elTextareaAsync.then((el) => el.focus());
    });
    __privateAdd(this, _handleClearBtnClick, () => {
      this.value = "";
      this.elTextareaAsync.then((element) => {
        var _a, _b;
        if (this.resizable === "manual") {
          element.style.height = "";
        } else if (this.resizable === "false") {
          const rowsToUse = (_a = this._initialRows) != null ? _a : this._defaultRows;
          this.rows = rowsToUse;
          element.style.setProperty("--_lines", rowsToUse.toString());
        } else {
          const rowsToUse = (_b = this._initialRows) != null ? _b : this._defaultRows;
          this.rows = rowsToUse;
          element.style.setProperty("--_lines", rowsToUse.toString());
          element.style.height = "";
        }
      });
      this.dispatchEvent(
        new Event("gds-input-cleared", {
          bubbles: true,
          composed: true
        })
      );
      this.dispatchEvent(
        new Event("input", {
          bubbles: true,
          composed: true
        })
      );
    });
    this.value = "";
  }
  /**
   * A reference to the clear button element. Returns null if there is no clear button.
   * Intended for use in integration tests.
   */
  test_getClearButton() {
    var _a;
    return (_a = this.shadowRoot) == null ? void 0 : _a.querySelector("#clear-button");
  }
  /**
   * A reference to the field element. This does not refer to the input element itself,
   * but the wrapper that makes up the visual field.
   * Intended for use in integration tests.
   */
  test_getFieldElement() {
    var _a;
    return (_a = this.shadowRoot) == null ? void 0 : _a.querySelector("#field");
  }
  _handleResize() {
    if (!this.fieldBase)
      return;
    Promise.resolve().then(() => {
      var _a;
      const fieldBaseShadowRoot = (_a = this.fieldBase) == null ? void 0 : _a.shadowRoot;
      if (!fieldBaseShadowRoot)
        return;
      const rightDiv = fieldBaseShadowRoot.querySelector(
        ".right"
      );
      if (rightDiv) {
        const boundingBox = rightDiv.getBoundingClientRect();
        this.elTextarea.style.setProperty(
          "--padding-inline-end",
          `${boundingBox.width}px`
        );
      } else {
        this.elTextarea.style.removeProperty("--padding-inline-end");
      }
    });
  }
  connectedCallback() {
    super.connectedCallback();
    if (this.hasAttribute("rows")) {
      this._initialRows = this.rows;
    }
    this._setAutoHeight();
    this.addEventListener("slotchange", this._handleSlotChange);
  }
  disconnectedCallback() {
    super.disconnectedCallback();
    this.removeEventListener("slotchange", this._handleSlotChange);
  }
  render() {
    return html`${choose(this.variant, [
      ["default", () => __privateMethod(this, _renderDefault, renderDefault_fn).call(this)],
      ["floating-label", () => __privateMethod(this, _renderFloatingLabel, renderFloatingLabel_fn).call(this)]
    ])}`;
  }
  _getValidityAnchor() {
    return this.elTextarea;
  }
  _setAutoHeight() {
    this.elTextareaAsync.then((element) => {
      var _a, _b, _c;
      if (this.resizable === "false") {
        const rowsToUse = (_a = this._initialRows) != null ? _a : this._defaultRows;
        this.rows = rowsToUse;
        element.style.setProperty("--_lines", rowsToUse.toString());
        return;
      }
      if (this.resizable === "manual") {
        return;
      }
      if (this.resizable === "auto") {
        if (element.value === "") {
          const rowsToUse = (_b = this._initialRows) != null ? _b : this._defaultRows;
          this.rows = rowsToUse;
          element.style.setProperty("--_lines", rowsToUse.toString());
        } else {
          const computedStyle = getComputedStyle(element);
          const lineHeight = parseFloat(computedStyle.lineHeight);
          const contentHeight = element.scrollHeight;
          const requiredRows = Math.ceil(contentHeight / lineHeight);
          const minRows = (_c = this._initialRows) != null ? _c : this._defaultRows;
          this.rows = Math.max(minRows, requiredRows);
          element.style.setProperty("--_lines", this.rows.toString());
        }
      }
    });
  }
  _handleRowsChange() {
    if (this.hasAttribute("rows")) {
      this._initialRows = this.rows;
    }
    this.elTextareaAsync.then((element) => {
      if (this.resizable === "false") {
        element.style.setProperty("--_lines", this.rows.toString());
      }
    });
  }
};
_renderDefault = new WeakSet();
renderDefault_fn = function() {
  var _a;
  return html`
      <gds-form-control-header class="size-${this.size}">
        <label for="input" slot="label">${this.label}</label>
        <span slot="supporting-text" id="supporting-text">
          ${this.supportingText}
        </span>
        <slot
          name="extended-supporting-text"
          slot="extended-supporting-text"
        ></slot>
      </gds-form-control-header>

      <gds-field-base
        id="field"
        .disabled=${this.disabled}
        .invalid=${this.invalid}
        @click=${__privateGet(this, _handleFieldClick)}
        multiline
      >
        ${__privateMethod(this, _renderFieldContents, renderFieldContents_fn).call(this)}
      </gds-field-base>

      <gds-form-control-footer
        lass="size-${this.size}"
        .charCounter=${__privateGet(this, _shouldShowRemainingChars, shouldShowRemainingChars_get) && this.maxlength - (((_a = this.value) == null ? void 0 : _a.length) || 0)}
        .validationMessage=${this.invalid && (this.errorMessage || this.validationMessage)}
      ></gds-form-control-footer>
    `;
};
_renderFloatingLabel = new WeakSet();
renderFloatingLabel_fn = function() {
  return nothing;
};
_forwardableAttrs = new WeakMap();
_handleOnInput = new WeakMap();
_handleOnChange = new WeakMap();
_handleOnPaste = new WeakMap();
_handleFieldClick = new WeakMap();
_handleClearBtnClick = new WeakMap();
_renderFieldContents = new WeakSet();
renderFieldContents_fn = function() {
  const elements = [
    __privateMethod(this, _renderSlotLead, renderSlotLead_fn).call(this),
    __privateMethod(this, _renderNativeTextarea, renderNativeTextarea_fn).call(this),
    __privateMethod(this, _renderClearButton, renderClearButton_fn).call(this),
    __privateMethod(this, _renderSlotTrail, renderSlotTrail_fn).call(this)
  ];
  return elements.map((element) => html`${element}`);
};
_renderSlotLead = new WeakSet();
renderSlotLead_fn = function() {
  return html`<slot slot="lead" name="lead"></slot>`;
};
_renderSlotTrail = new WeakSet();
renderSlotTrail_fn = function() {
  return html`<slot slot="trail" name="trail"></slot>`;
};
_renderNativeTextarea = new WeakSet();
renderNativeTextarea_fn = function() {
  return html`
      <textarea
        @input=${__privateGet(this, _handleOnInput)}
        @change=${__privateGet(this, _handleOnChange)}
        @paste=${__privateGet(this, _handleOnPaste)}
        .value=${this.value}
        id="input"
        class="resize-${this.resizable}"
        aria-describedby="supporting-text extended-supporting-text sub-label message"
        placeholder=" "
        ${forwardAttributes(__privateGet(this, _forwardableAttrs))}
      ></textarea>
    `;
};
_renderClearButton = new WeakSet();
renderClearButton_fn = function() {
  var _a;
  if (this.clearable && (((_a = this.value) == null ? void 0 : _a.length) || 0) > 0)
    return html`
        <gds-button
          size="small"
          rank="tertiary"
          variant="${this.invalid ? "negative" : ""}"
          ?disabled="${this.disabled}"
          label="${msg("Clear input")}"
          @click=${__privateGet(this, _handleClearBtnClick)}
          slot="action"
          id="clear-button"
        >
          <gds-icon-cross-large></gds-icon-cross-large>
        </gds-button>
      `;
  else
    return nothing;
};
_shouldShowRemainingChars = new WeakSet();
shouldShowRemainingChars_get = function() {
  return this.maxlength < Number.MAX_SAFE_INTEGER;
};
Textarea.styles = [tokens, styles];
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => v,
    selector: "textarea",
    styleTemplate: (_prop, values) => {
      const ROWS = values[0];
      return `min-height: calc(1lh * ${ROWS});`;
    }
  })
], Textarea.prototype, "rows", 2);
__decorateClass([
  property({ attribute: "supporting-text" })
], Textarea.prototype, "supportingText", 2);
__decorateClass([
  property({ type: Boolean })
], Textarea.prototype, "clearable", 2);
__decorateClass([
  property({ type: String })
], Textarea.prototype, "resizable", 2);
__decorateClass([
  property({ type: Number })
], Textarea.prototype, "maxlength", 2);
__decorateClass([
  property({ type: String })
], Textarea.prototype, "variant", 2);
__decorateClass([
  property({ type: String })
], Textarea.prototype, "size", 2);
__decorateClass([
  queryAsync("textarea")
], Textarea.prototype, "elTextareaAsync", 2);
__decorateClass([
  query("textarea")
], Textarea.prototype, "elTextarea", 2);
__decorateClass([
  query("gds-field-base")
], Textarea.prototype, "fieldBase", 2);
__decorateClass([
  resizeObserver()
], Textarea.prototype, "_handleResize", 1);
__decorateClass([
  watch("value")
], Textarea.prototype, "_setAutoHeight", 1);
__decorateClass([
  watch("rows")
], Textarea.prototype, "_handleRowsChange", 1);
Textarea = __decorateClass([
  localized()
], Textarea);
var GdsTextarea = class extends withLayoutChildProps(
  withSizeXProps(withMarginProps(Textarea))
) {
};
GdsTextarea = __decorateClass([
  gdsCustomElement("gds-textarea")
], GdsTextarea);

export {
  GdsTextarea
};
