import {
  withLayoutChildProps,
  withMarginProps,
  withPositioningProps,
  withSizeXProps,
  withSizeYProps
} from "./chunk.TWXTKG4B.js";
import {
  styleExpressionProperty
} from "./chunk.NUUST5OZ.js";
import {
  tokens
} from "./chunk.FI4AQLJC.js";
import {
  GdsElement
} from "./chunk.TMEWQZER.js";
import {
  gdsCustomElement,
  html
} from "./chunk.QK3R23GV.js";
import {
  __decorateClass
} from "./chunk.SEHSDSX2.js";

// libs/core/src/components/video/video.ts
import { property, query } from "lit/decorators.js";

// libs/core/src/components/video/video.style.ts
import { css } from "lit";
var style = css`
  :host {
    display: block;
    margin: 0;
    padding: 0;
    box-sizing: border-box;
    font-size: 0;
    width: 100%;
    height: auto;
    overflow: hidden;
  }

  video {
    display: flex;
    width: 100%;
    height: 100%;
  }
`;
var video_style_default = style;

// libs/core/src/components/video/video.ts
var GdsVideo = class extends withSizeXProps(
  withSizeYProps(
    withMarginProps(withLayoutChildProps(withPositioningProps(GdsElement)))
  )
) {
  // Method to programmatically apply video settings
  applyVideoSettings() {
    if (this.videoElement) {
      this.videoElement.src = this.src || "";
      this.videoElement.poster = this.poster || "";
      this.videoElement.muted = this.muted || false;
      this.videoElement.autoplay = this.autoplay || false;
      this.videoElement.loop = this.loop || false;
      this.videoElement.playsInline = this.playsinline || false;
    }
  }
  render() {
    return html`<video></video>`;
  }
  firstUpdated() {
    this.applyVideoSettings();
  }
};
GdsVideo.styles = [tokens, video_style_default];
__decorateClass([
  styleExpressionProperty()
], GdsVideo.prototype, "aspect-ratio", 2);
__decorateClass([
  styleExpressionProperty({
    selector: "video"
  })
], GdsVideo.prototype, "object-position", 2);
__decorateClass([
  styleExpressionProperty()
], GdsVideo.prototype, "opacity", 2);
__decorateClass([
  styleExpressionProperty({
    selector: "video"
  })
], GdsVideo.prototype, "object-fit", 2);
__decorateClass([
  styleExpressionProperty({
    selector: "video"
  })
], GdsVideo.prototype, "pointer-events", 2);
__decorateClass([
  styleExpressionProperty({
    valueTemplate: (v) => `var(--gds-space-${v})`
  })
], GdsVideo.prototype, "border-radius", 2);
__decorateClass([
  property()
], GdsVideo.prototype, "src", 2);
__decorateClass([
  property()
], GdsVideo.prototype, "poster", 2);
__decorateClass([
  property({ type: Boolean })
], GdsVideo.prototype, "muted", 2);
__decorateClass([
  property({ type: Boolean })
], GdsVideo.prototype, "playsinline", 2);
__decorateClass([
  property({ type: Boolean })
], GdsVideo.prototype, "autoplay", 2);
__decorateClass([
  property({ type: Boolean })
], GdsVideo.prototype, "loop", 2);
__decorateClass([
  query("video")
], GdsVideo.prototype, "videoElement", 2);
GdsVideo = __decorateClass([
  gdsCustomElement("gds-video")
], GdsVideo);

export {
  GdsVideo
};
