import {
  tokens
} from "./chunk.FI4AQLJC.js";
import {
  gdsCustomElement
} from "./chunk.QK3R23GV.js";
import {
  __decorateClass
} from "./chunk.SEHSDSX2.js";

// libs/core/src/primitives/ripple/ripple.ts
import { html, LitElement, unsafeCSS } from "lit";
import { query } from "lit/decorators.js";

// libs/core/src/primitives/ripple/ripple.styles.scss?inline
var ripple_styles_default = `:host {
  --gds-ripple-motion-name: ripple;
  --gds-ripple-motion: var(--gds-ripple-motion-name) 1.25s
    cubic-bezier(0.16, 1, 0.3, 1) 0s 1 normal none running;
  border-radius: var(--gds-space-max);
  contain: strict;
  display: grid;
  place-content: center;
  height: 100%;
  inset: 0;
  overflow: hidden;
  position: absolute;
  width: 100%;
}

div {
  background-color: currentColor;
  border-radius: var(--gds-space-max);
  display: flex;
  height: 100%;
  left: calc((-50% + var(--gds-ripple-left)) / 4);
  opacity: 0;
  pointer-events: none;
  position: absolute;
  top: 0;
  width: 100%;
  will-change: transform;
}

div.gds-ripple-effect {
  animation: var(--gds-ripple-motion);
}

@keyframes ripple {
  from {
    opacity: 0.2;
    transform: scale(0.6, 1);
  }
  to {
    opacity: 0;
    transform: scale(1.25);
  }
}
@media (prefers-reduced-motion: reduce) {
  :host {
    --gds-ripple-motion-name: none !important;
  }
}`;

// libs/core/src/primitives/ripple/ripple.ts
var Ripple = class extends LitElement {
  constructor() {
    super(...arguments);
    this.onmousedown = (e) => {
      const target = e.target;
      const rect = target.getBoundingClientRect();
      const rippleEl = this._rippleEl;
      if (rippleEl) {
        rippleEl.classList.remove("gds-ripple-effect");
        this.style.setProperty("--gds-ripple-top", `${e.clientY - rect.top}px`);
        this.style.setProperty("--gds-ripple-left", `${e.clientX - rect.left}px`);
        setTimeout(() => {
          rippleEl.classList.add("gds-ripple-effect");
        }, 20);
      }
    };
  }
  render() {
    return html`<div></div>`;
  }
};
Ripple.styles = [tokens, unsafeCSS(ripple_styles_default)];
__decorateClass([
  query("div")
], Ripple.prototype, "_rippleEl", 2);
Ripple = __decorateClass([
  gdsCustomElement("gds-ripple")
], Ripple);

export {
  Ripple
};
