import {
  TransitionalStyles
} from "./chunk.EUES6BVY.js";
import {
  watch
} from "./chunk.TYGMNHNO.js";
import {
  dark_default,
  light_default,
  tokens
} from "./chunk.FI4AQLJC.js";
import {
  GdsElement
} from "./chunk.TMEWQZER.js";
import {
  gdsCustomElement,
  html
} from "./chunk.QK3R23GV.js";
import {
  __decorateClass
} from "./chunk.SEHSDSX2.js";

// libs/core/src/components/theme/theme.ts
import { css, unsafeCSS } from "lit";
import { property } from "lit/decorators.js";
var GdsTheme = class extends GdsElement {
  constructor() {
    super(...arguments);
    this.colorScheme = "light";
    this.designVersion = "2016";
  }
  connectedCallback() {
    super.connectedCallback();
    TransitionalStyles.instance.apply(this, "gds-theme");
    this._dynamicStylesController.inject(
      "dark",
      unsafeCSS(`:host {${dark_default}}`)
    );
  }
  render() {
    return html`<slot></slot>`;
  }
  _onColorSchemeChange() {
    if (this.colorScheme === "dark") {
      this._dynamicStylesController.inject(
        "color-scheme",
        unsafeCSS(`:host { ${dark_default}}`)
      );
    } else {
      this._dynamicStylesController.inject(
        "color-scheme",
        unsafeCSS(`:host { ${light_default}}`)
      );
    }
    this.dispatchEvent(
      new CustomEvent("gds-color-scheme-changed", {
        detail: { colorScheme: this.colorScheme }
      })
    );
  }
  _onDesignVersionChange() {
    this.dispatchEvent(
      new CustomEvent("gds-design-version-changed", {
        detail: { designVersion: this.designVersion }
      })
    );
  }
};
GdsTheme.styles = [
  tokens,
  css`
      :host {
        display: contents;
      }
    `
];
__decorateClass([
  property({ reflect: true, attribute: "color-scheme" })
], GdsTheme.prototype, "colorScheme", 2);
__decorateClass([
  property({ reflect: true, attribute: "design-version" })
], GdsTheme.prototype, "designVersion", 2);
__decorateClass([
  watch("colorScheme")
], GdsTheme.prototype, "_onColorSchemeChange", 1);
__decorateClass([
  watch("designVersion")
], GdsTheme.prototype, "_onDesignVersionChange", 1);
GdsTheme = __decorateClass([
  gdsCustomElement("gds-theme")
], GdsTheme);

export {
  GdsTheme
};
