import {
  withPositioningProps,
  withSizeXProps,
  withSizeYProps
} from "./chunk.TWXTKG4B.js";
import {
  styleExpressionProperty
} from "./chunk.NUUST5OZ.js";
import {
  tokens
} from "./chunk.FI4AQLJC.js";
import {
  GdsElement
} from "./chunk.TMEWQZER.js";
import {
  gdsCustomElement,
  html
} from "./chunk.QK3R23GV.js";
import {
  __decorateClass
} from "./chunk.SEHSDSX2.js";

// libs/core/src/components/img/img.ts
import { property } from "lit/decorators.js";

// libs/core/src/components/img/img.style.ts
import { css } from "lit";
var style = css`
  :host {
    display: block;
    margin: 0;
    padding: 0;
    box-sizing: border-box;
    font-size: 0;
    width: 100%;
    height: auto;
    overflow: hidden;
  }

  img {
    display: flex;
    width: 100%;
    height: 100%;
  }
`;
var img_style_default = style;

// libs/core/src/components/img/img.ts
var GdsImg = class extends withPositioningProps(
  withSizeXProps(withSizeYProps(GdsElement))
) {
  render() {
    return html`<img src="${this.src}" alt="${this.alt}" />`;
  }
};
GdsImg.styles = [tokens, img_style_default];
__decorateClass([
  styleExpressionProperty()
], GdsImg.prototype, "aspect-ratio", 2);
__decorateClass([
  styleExpressionProperty({
    property: "border-radius",
    valueTemplate: (v) => `var(--gds-space-${v})`
  })
], GdsImg.prototype, "border-radius", 2);
__decorateClass([
  styleExpressionProperty({
    selector: "img"
  })
], GdsImg.prototype, "object-fit", 2);
__decorateClass([
  styleExpressionProperty({
    selector: "img"
  })
], GdsImg.prototype, "object-position", 2);
__decorateClass([
  property()
], GdsImg.prototype, "src", 2);
__decorateClass([
  property()
], GdsImg.prototype, "alt", 2);
GdsImg = __decorateClass([
  gdsCustomElement("gds-img")
], GdsImg);

export {
  GdsImg
};
