import { GdsElement } from '../../gds-element';
/**
 * @element gds-icon
 * @status stable
 *
 * @part icon - The icon SVG element.
 */
export declare abstract class GdsIcon extends GdsElement {
    static styles: import("lit").CSSResult[];
    /**
     * This property allow you to set the width of the icon. If not provided, the default width is 24px.
     */
    width?: number;
    /**
     * This property allow you to set the height of the icon. If not provided, the default height is 24px.
     */
    height?: number;
    /**
     * When set to true, the solid version of the icon is displayed. When set to false or not provided, the regular version of the icon is displayed.
     */
    solid: boolean;
    /**
     * When set to true, you can apply custom stroke width to the icon.
     */
    stroke?: number;
    /**
     * When viewbox is defined it will override the default viewbox of the icon.
     */
    box: boolean;
    /**
     * This property allow you to set the accessible label of the icon. If not provided, the default label is the name of the icon.
     */
    label: string;
    protected static _name: string;
    protected static _regularSVG?: string;
    protected static _solidSVG?: string;
    render(): import("lit-html").TemplateResult<1>;
}
