import { GdsElement } from '../../gds-element';
/**
 * @element gds-field-base
 * @status beta
 * @internal
 *
 * gds-field-base is a primitive that provides a reusable base structure for the "field" part of form controls in Green Core.
 *
 * @slot - Default slot for main content.
 * @slot lead - Slot for leading content.
 * @slot action - Slot for action content.
 * @slot trail - Slot for trailing content.
 */
export declare class GdsFieldBase extends GdsElement {
    #private;
    static styles: import("lit").CSSResult[];
    /**
     * The size of the field.
     */
    size: 'large' | 'small';
    /**
     * Whether the field is multiline (ie, textarea).
     */
    multiline: boolean;
    /**
     * Whether the field is disabled.
     */
    disabled: boolean;
    /**
     * Whether the field is invalid.
     */
    invalid: boolean;
    private _mainSlotElement;
    private _leadSlotOccupied;
    private _trailSlotOccupied;
    private _actionSlotOccupied;
    constructor();
    connectedCallback(): void;
    render(): any;
    private _handleDisabledChange;
}
