import { CSSResult } from 'lit';
declare global {
    var __gdsGlobalStylesRegistry: GlobalStylesRegistry;
}
export declare class GlobalStylesRegistry {
    #private;
    /**
     * Get the global singleton instance of the GlobalStylesRegistry.
     */
    static get instance(): GlobalStylesRegistry;
    /**
     * Injects global styles into the document. This function is intended to be used for global styles
     * that cannot be scoped to a specific component.
     *
     * @param key unique identifier for this stylesheet.
     * @param styles CSSResult produced by the lit css template literal tag
     */
    injectGlobalStyles(key: string, styles: CSSResult): void;
}
